routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\CourseController;
use App\Http\Controllers\LevelController;
use App\Http\Controllers\UserController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
})->middleware('auth');

Route::resource('category', CategoryController::class)->middleware('auth');
Route::resource('course', CourseController::class)->middleware('auth');
Route::resource('level', LevelController::class)->middleware('auth');
Route::resource('user', UserController::class)->middleware('auth');


Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home')->middleware('auth');

app/Models/Level.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Level extends Model
{
    use HasFactory;
    protected $guarded = [];


    public function statusOptions(){
        return [
            1 => 'Active',
            0 => 'Inactive',
            2 => 'In-Progress'
        ];
    }
}

app/Http/Controllers/LevelController.php
<?php

namespace App\Http\Controllers;

use App\Models\Level;
use Illuminate\Http\Request;

class LevelController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        $models = Level::all();
        return view('level.index', compact('models'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $level = new Level();
        return view('level.create', compact('level'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
//        dd($request);//die();
        if(!isset($request['status'])){
            $request['status'] = 0;
        }
        $model = Level::create($this->validateRequest());
        return redirect('level');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Level  $model
     * @return \Illuminate\Http\Response
     */
    public function show(Level $model)
    {
        return view('level.show',compact('model'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Level  $model
     * @return \Illuminate\Http\Response
     */
    public function edit(Level $level)
    {
        return view('level.edit', compact('level'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Level  $model
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Level $model)
    {

        if(!isset($request['status'])){
            $request['status'] = 0;
        }
        $model->update($this->validateRequest());
        //dd($request);
        return redirect('level/'.$model->id);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Level  $model
     * @return \Illuminate\Http\Response
     */
    public function destroy(Level $model)
    {
        $model->delete();
        return redirect('model');
    }

    private function validateRequest()
    {
        return \request()->validate([
            'ar_name' => 'required',
            'en_name' => 'required',
            'status' => 'integer',
        ]);
    }
}

resources/views/level/create.blade.php
@extends('layouts.app')

@section('title', 'Add New Level')


@section('content')

    <div class="row">
        <div class="col-12">
            <form action="{{route('level.store')}}" method="POST" class="" enctype="multipart/form-data">

                @include('level.form')

            </form>
        </div>
    </div>
    <hr>

@endsection()

resources/views/level/edit.blade.php
@extends('layouts.app')

@section('title', 'Edit Details for '. $level->en_name)


@section('content')
    <div class="row">
        <div class="col-12">
            <h1>Edit Details for {{ $level->en_name }}</h1>
        </div>
    </div>

    <div class="row">
        <div class="col-12">
            <form action=" {{route('level.update', ['level' => $level])}}" method="POST" class="" enctype="multipart/form-data">
                @method('PATCH')
                @include('level.form')

            </form>
        </div>
    </div>
    <hr>

@endsection()

resources/views/level/form.blade.php
@csrf
<div class="col-md-6 col-12">
    <div class="card" style="height: 420.283px;">
        <div class="card-header">
            <h4 class="card-title">@yield('title')</h4>
        </div>
        <div class="card-content">
            <div class="card-body">
                <form class="form form-horizontal">
                    <div class="form-body">
                        <div class="row">
                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Arabic Name</span>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="text" name="ar_name" value="{{ old('ar_name') ?? $level->ar_name }}" class="form-control">
                                    </div>
                                    <div>{{ $errors->first('ar_name') }}</div>
                                </div>
                            </div>
                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>English Name</span>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="text" name="en_name" value="{{ old('en_name') ?? $level->en_name }}" class="form-control">
                                    </div>
                                    <div>{{ $errors->first('en_name') }}</div>
                                </div>
                            </div>
                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Status</span>
                                    </div>
                                    <div class="col-md-8">
                                        <div class="custom-control custom-switch custom-switch-success mr-2 mb-1">
                                            <p class="mb-0">Active</p>
                                            <?php
                                                $checked = $level->status ? 'checked': '';
                                            ?>
                                            <input type="checkbox" value="1"  {{ $checked}} class="custom-control-input" id="customSwitch4" name="status">
                                            <label class="custom-control-label" for="customSwitch4"></label>
                                        </div>
                                        <div>{{ $errors->first('status') }}</div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-md-8 offset-md-4">
                                <button type="submit" class="btn btn-primary mr-1 mb-1 waves-effect waves-light">Submit</button>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

resources/views/level/index.blade.php
<?php
?>
@extends('layouts.app')

@section('title', 'Levels List')


@section('content')
    <section id="grid-options" class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-title">@yield('title')</h4>
                    <a class="btn btn-success btn-sm pull-right" href="{{route('level.create')}}">Create</a>
                </div>
                <div class="card-content">
                    <div class="card-body">
                        <div class="table-responsive">
                            <table class="table table-bordered table-striped">
                                <thead>
                                <tr>
                                    <th></th>
                                    <th class="text-center">
                                       English Name
                                    </th>
                                    <th class="text-center">
                                       Arabic Name
                                    </th>
                                    <th class="text-center">
                                        Status
                                    </th>
                                    <th class="text-center">
                                        Actions
                                    </th>
                                </tr>
                                </thead>
                                <tbody style="text-align: center">
                                @foreach($models as $model)
                                    <tr>
                                        <td> {{ $model->id }}</td>
                                        <td><a href="/model/{{ $model->id }}">{{ $model->en_name }}</a></td>
                                        <td>{{ $model->en_name }}</td>
                                        <td>{{ $model->statusOptions()[$model->status] }}</td>
                                        <td>
                                            <a href="{{route('level.edit', ['level' => $model])}}"><i class="fa fa-edit"></i></a>
                                            <a href="{{route('level.show', ['level' => $model])}}"><i class="fa fa-eye"></i></a>
                                            <form action="{{route('level.destroy', ['level' => $model])}}" method="POST">
                                                @method('DELETE')
                                                @csrf
                                                <button class="btn btn danger" type="submit"><i class="fa fa-trash"></i></button>
                                            </form>
                                        </td>
                                    </tr>
                                @endforeach
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection()

resources/views/level/show.blade.php
@extends('layouts.app')

@section('title', 'Details for ' . $model->ar_name)


@section('content')
    <div class="row">
        <div class="col-12">
            <h1>{{'Details for ' . $model->ar_name}}</h1>
            <p style="float: right;padding: 0;margin: 0;">
                <a href="/level/{{ $model->id }}/edit">Edit</a>
            </p>
            <form action="/level/{{ $model->id }}" method="POST" style="width: 7%;float: right;margin-top: -10px;">
                @method('DELETE')
                @csrf
                <button class="btn btn danger" type="submit">Delete</button>
            </form>

        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <table class="table table-bordered table-striped">
                <tr>
                    <th>Id</th>
                    <td>{{$model->id}}</td>
                </tr>
                <tr>
                    <th>Ar Name</th>
                    <td>{{$model->ar_name}}</td>
                </tr>
                <tr>
                    <th>En Name</th>
                    <td>{{$model->en_name}}</td>
                </tr>
            </table>
        </div>
    </div>
@endsection()